signature PARSER =
  sig
    exception Internal of string
    exception Parse of Pos.pos * string

    (* core *)
    val parseKind : (Fomega.kind, Tokens.token) Parsing.parser
    val parseCon : (Fomega.con, Tokens.token) Parsing.parser
    val parseExp : (Fomega.exp, Tokens.token) Parsing.parser
    val parseProgram : (Fomega.exp list, Tokens.token) Parsing.parser

    val parseFile : ('a, Tokens.token) Parsing.parser -> string -> 'a
    val parseString : ('a, Tokens.token) Parsing.parser -> string -> 'a
    val withHandler : ('a -> 'b) -> 'a -> 'b
  end
