functor SymTableFn(K : sig
                        type symbol
                        type value
                        val compare : symbol * symbol -> order
                        val generate : symbol -> value
                       end) : SymTable
                              where type symbol = K.symbol
                                and type value = K.value =
  struct
    type symbol = K.symbol
    type value = K.value
    structure VarMap =
      SplayMapFn(struct type ord_key = symbol val compare = K.compare end)
    type table = value VarMap.map ref

    val empty = (ref VarMap.empty : table)

    fun get t k =
      case VarMap.find (!t, k) of
        SOME v => v
      | NONE =>
        let
          val v = K.generate k
          val () = t := VarMap.insert (!t, k, v)
        in
          v
        end
  end
